routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['install']], function () {
	
	Route::get('/', function(){
		return redirect('login');
	});
	
    Auth::routes(['register' => false]);
	Route::get('/logout', 'Auth\LoginController@logout');
	
	Route::group(['middleware' => ['auth','verified']], function () {
		
		Route::get('dashboard', 'DashboardController@index');
		
		//Profile Controller
		Route::get('profile/edit', 'ProfileController@edit');
		Route::post('profile/update', 'ProfileController@update');
		Route::get('profile/change_password', 'ProfileController@change_password');
		Route::post('profile/update_password', 'ProfileController@update_password');
		

		/** Admin Only Route **/
		Route::group(['middleware' => ['admin']], function () {
			
			//User Management
			Route::resource('users','UserController');

			//User Roles
			Route::resource('roles','RoleController');
			
			//Permission Controller
		    Route::get('permission/control/{user_id?}', 'PermissionController@index')->name('permission.index');
			Route::post('permission/store', 'PermissionController@store')->name('permission.store');

			//Language Controller
			Route::resource('languages','LanguageController');	
			
			//Utility Controller
			Route::match(['get', 'post'],'administration/general_settings/{store?}', 'UtilityController@settings')->name('settings.update_settings');
			Route::post('administration/upload_logo', 'UtilityController@upload_logo')->name('settings.uplaod_logo');
			Route::get('administration/database_backup_list', 'UtilityController@database_backup_list')->name('database_backups.list');
			Route::get('administration/create_database_backup', 'UtilityController@create_database_backup')->name('database_backups.create');
			Route::delete('administration/destroy_database_backup/{id}', 'UtilityController@destroy_database_backup');
			Route::get('administration/download_database_backup/{id}', 'UtilityController@download_database_backup')->name('database_backups.download');
			Route::post('administration/remove_cache', 'UtilityController@remove_cache')->name('settings.remove_cache');

			//Email Template
			/*Route::resource('email_templates','EmailTemplateController')->only([
				'index', 'create', 'store', 'show', 'edit', 'update', 'destroy'
			]);*/	
			
		});

        /** Dynamic Permission **/
		Route::group(['middleware' => ['permission']], function () {
			
			//Customer Controller
			Route::resource('customers','CustomerController');

			//Vendor Controller
			Route::resource('vendors','VendorController');

			//Account Controller
			Route::resource('accounts','AccountController');

			//Income Controller
			Route::get('income/get_table_data','IncomeController@get_table_data');
			Route::resource('income','IncomeController');

			//Expense Controller
			Route::get('expense/get_table_data','ExpenseController@get_table_data');
			Route::resource('expense','ExpenseController');

			//Currency Controller
			Route::resource('currency','CurrencyController');

			//Income & Expense Category
			Route::resource('transaction_categories','CategoryController');

			//Transfer Controller
			Route::resource('transfers','TransferController');

			//Payment Methods
			Route::resource('payment_methods','PaymentMethodController');

			//Reports Controller
			Route::match(['get','post'],'reports/income_summary','ReportController@income_summary')->name('reports.income_summary');
			Route::match(['get','post'],'reports/expense_summary','ReportController@expense_summary')->name('reports.expense_summary');

			Route::match(['get','post'],'reports/income_expense_summary','ReportController@income_expense_summary')->name('reports.income_expense_summary');

		});
	
	});

});

//Socila Login
Route::get('/login/{provider}', 'Auth\SocialController@redirect');
Route::get('/login/{provider}/callback','Auth\SocialController@callback');

//JSON data for dashboard chart
Route::get('dashboard/json_month_wise_income_expense','DashboardController@json_month_wise_income_expense')->middleware('auth');
Route::get('dashboard/json_income_by_category','DashboardController@json_income_by_category')->middleware('auth');
Route::get('dashboard/json_expense_by_category','DashboardController@json_expense_by_category')->middleware('auth');

//Ajax Select2 Controller
Route::get('ajax/get_table_data','Select2Controller@get_table_data');

Route::get('/installation', 'Install\InstallController@index');
Route::get('install/database', 'Install\InstallController@database');
Route::post('install/process_install', 'Install\InstallController@process_install');
Route::get('install/create_user', 'Install\InstallController@create_user');
Route::post('install/store_user', 'Install\InstallController@store_user');
Route::get('install/system_settings', 'Install\InstallController@system_settings');
Route::post('install/finish', 'Install\InstallController@final_touch');

//Update System
Route::get('migration/update', 'Install\UpdateController@update_migration');

app/Account.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Account extends Model
{
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'accounts';

    public function currency(){
    	return $this->belongsTo('App\Currency','currency_id')->withDefault();
    }

    public function getCreatedAtAttribute($value)
    {
		$date_format = get_date_format();
		$time_format = get_time_format();
        return \Carbon\Carbon::parse($value)->format("$date_format $time_format");
    }
}

app/Http/Controllers/AccountController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Account;
use Validator;

class AccountController extends Controller
{
	
	/**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        date_default_timezone_set(get_option('timezone','Asia/Dhaka'));
    }
	
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $accounts = Account::all()->sortByDesc("id");
        return view('backend.account.list',compact('accounts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        if( ! $request->ajax()){
           return view('backend.account.create');
        }else{
           return view('backend.account.modal.create');
        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {	
        $validator = Validator::make($request->all(), [
            'name' => 'required',
			'currency_id' => 'required',
			'openning_balance' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            if($request->ajax()){ 
                return response()->json(['result'=>'error','message'=>$validator->errors()->all()]);
            }else{
                return redirect()->route('accounts.create')
                	             ->withErrors($validator)
                	             ->withInput();
            }			
        }
	
        
        $account = new Account();
        $account->name = $request->input('name');
		$account->account_no = $request->input('account_no');
		$account->currency_id = $request->input('currency_id');
		$account->openning_balance = $request->input('openning_balance');
		$account->contact_person = $request->input('contact_person');
		$account->contact_email = $request->input('contact_email');
		$account->note = $request->input('note');

        $account->save();
        $account->currency_id = $account->currency->name;
        $account->openning_balance = decimalPlace($account->openning_balance, $account->currency->name);

        if(! $request->ajax()){
           return redirect()->route('accounts.create')->with('success', _lang('Saved Successfully'));
        }else{
           return response()->json(['result'=>'success','action'=>'store','message'=>_lang('Saved Successfully'),'data'=>$account, 'table' => '#accounts_table']);
        }
        
   }
	

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,$id)
    {
        $account = Account::find($id);
        if(! $request->ajax()){
            return view('backend.account.view',compact('account','id'));
        }else{
            return view('backend.account.modal.view',compact('account','id'));
        } 
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Request $request,$id)
    {
        $account = Account::find($id);
        if(! $request->ajax()){
            return view('backend.account.edit',compact('account','id'));
        }else{
            return view('backend.account.modal.edit',compact('account','id'));
        }  
        
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
		$validator = Validator::make($request->all(), [
			'name' => 'required',
			'currency_id' => 'required',
			'openning_balance' => 'required|numeric',
		]);

		if ($validator->fails()) {
			if($request->ajax()){ 
				return response()->json(['result'=>'error','message'=>$validator->errors()->all()]);
			}else{
				return redirect()->route('accounts.edit', $id)
							->withErrors($validator)
							->withInput();
			}			
		}
	
        	
		
        $account = Account::find($id);
		$account->name = $request->input('name');
		$account->account_no = $request->input('account_no');
		$account->currency_id = $request->input('currency_id');
		$account->openning_balance = $request->input('openning_balance');
		$account->contact_person = $request->input('contact_person');
		$account->contact_email = $request->input('contact_email');
		$account->note = $request->input('note');
	
        $account->save();
        $account->currency_id = $account->currency->name;
        $account->openning_balance = decimalPlace($account->openning_balance, $account->currency->name);
		
		if(! $request->ajax()){
           return redirect()->route('accounts.index')->with('success', _lang('Updated Successfully'));
        }else{
		   return response()->json(['result'=>'success','action'=>'update', 'message'=>_lang('Updated Successfully'),'data'=>$account, 'table' => '#accounts_table']);
		}
	    
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $account = Account::find($id);
        $account->delete();
        return redirect()->route('accounts.index')->with('success',_lang('Deleted Successfully'));
    }
}

resources/views/backend/account/create.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
	<div class="col-lg-12">
		<div class="card">
			<div class="card-header">
				<span class="panel-title">{{ _lang('Add Account') }}</span>
			</div>
			<div class="card-body">
			    <form method="post" class="validate" autocomplete="off" action="{{ route('accounts.store') }}" enctype="multipart/form-data">
					{{ csrf_field() }}
					<div class="row">
						<div class="col-md-6">
					        <div class="form-group">
						        <label class="control-label">{{ _lang('Name') }}</label>						
						        <input type="text" class="form-control" name="name" value="{{ old('name') }}" required>
					        </div>
					    </div>

						<div class="col-md-6">
					        <div class="form-group">
						        <label class="control-label">{{ _lang('Account No') }}</label>						
						        <input type="text" class="form-control" name="account_no" value="{{ old('account_no') }}">
					        </div>
					    </div>

						<div class="col-md-6">
					        <div class="form-group">
						        <label class="control-label">{{ _lang('Account Currency') }}</label>						
						        <select class="form-control auto-select select2" data-selected="{{ old('currency_id') }}" name="currency_id" required>
					                <option value="">{{ _lang('Select One') }}</option>
									{{ create_option('currency','id','name',old('currency_id'), array('status='=>1)) }}
								</select>
							</div>
					    </div>

						<div class="col-md-6">
					        <div class="form-group">
						        <label class="control-label">{{ _lang('Openning Balance') }}</label>						
						        <input type="text" class="form-control float-field" name="openning_balance" value="{{ old('openning_balance') }}" required>
					        </div>
					    </div>

						<div class="col-md-6">
					        <div class="form-group">
						        <label class="control-label">{{ _lang('Contact Person') }}</label>						
						        <input type="text" class="form-control" name="contact_person" value="{{ old('contact_person') }}">
					        </div>
					    </div>

						<div class="col-md-6">
					        <div class="form-group">
						        <label class="control-label">{{ _lang('Contact Email') }}</label>						
						        <input type="text" class="form-control" name="contact_email" value="{{ old('contact_email') }}">
					        </div>
					    </div>

						<div class="col-md-6">
						    <div class="form-group">
							    <label class="control-label">{{ _lang('Note') }}</label>						
							    <textarea class="form-control" name="note">{{ old('note') }}</textarea>
						    </div>
						</div>

							
						<div class="col-md-12">
							<div class="form-group">
								<button type="submit" class="btn btn-primary">{{ _lang('Save') }}</button>
							</div>
						</div>
					</div>			
			    </form>
			</div>
		</div>
    </div>
</div>
@endsection

resources/views/backend/account/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
	<div class="col-lg-12">
		<div class="card">
			<div class="card-header">
				<span class="panel-title">{{ _lang('Update Account') }}</span>
			</div>
			<div class="card-body">
				<form method="post" class="validate" autocomplete="off" action="{{ action('AccountController@update', $id) }}" enctype="multipart/form-data">
					{{ csrf_field()}}
					<input name="_method" type="hidden" value="PATCH">				
					<div class="row">
						<div class="col-md-6">
						    <div class="form-group">
							   <label class="control-label">{{ _lang('Name') }}</label>						
							   <input type="text" class="form-control" name="name" value="{{ $account->name }}" required>
						    </div>
						</div>

						<div class="col-md-6">
						    <div class="form-group">
							   <label class="control-label">{{ _lang('Account No') }}</label>						
							   <input type="text" class="form-control" name="account_no" value="{{ $account->account_no }}">
						    </div>
						</div>

						<div class="col-md-6">
						    <div class="form-group">
							    <label class="control-label">{{ _lang('Account Currency') }}</label>						
							    <select class="form-control auto-select select2" data-selected="{{ $account->currency_id }}" name="currency_id" required>
					                <option value="">{{ _lang('Select One') }}</option>
									{{ create_option('currency','id','name',$account->currency_id, array('status='=>1)) }}
							    </select>
						    </div>
						</div>

						<div class="col-md-6">
						    <div class="form-group">
							   <label class="control-label">{{ _lang('Openning Balance') }}</label>						
							   <input type="text" class="form-control float-field" name="openning_balance" value="{{ $account->openning_balance }}" required>
						    </div>
						</div>

						<div class="col-md-6">
						    <div class="form-group">
							   <label class="control-label">{{ _lang('Contact Person') }}</label>						
							   <input type="text" class="form-control" name="contact_person" value="{{ $account->contact_person }}">
						    </div>
						</div>

						<div class="col-md-6">
						    <div class="form-group">
							   <label class="control-label">{{ _lang('Contact Email') }}</label>						
							   <input type="text" class="form-control" name="contact_email" value="{{ $account->contact_email }}">
						    </div>
						</div>

						<div class="col-md-6">
						    <div class="form-group">
							   <label class="control-label">{{ _lang('Note') }}</label>						
							   <textarea class="form-control" name="note">{{ $account->note }}</textarea>
						    </div>
						</div>

							
						<div class="col-md-12">
							<div class="form-group">
								<button type="submit" class="btn btn-primary">{{ _lang('Update') }}</button>
							</div>
						</div>	
					</div>	
				</form>
			</div>
		</div>
	</div>
</div>

@endsection

resources/views/backend/account/list.blade.php
@extends('layouts.app')

@section('content')

<div class="row">
	<div class="col-lg-12">
		<div class="card no-export">
		    <div class="card-header">
				<span class="panel-title">{{ _lang('Account List') }}</span>
				<button class="btn btn-primary btn-xs float-right ajax-modal" data-title="{{ _lang('Add Account') }}" data-href="{{ route('accounts.create') }}">{{ _lang('Add New') }}</button>
			</div>
			<div class="card-body">
				<table id="accounts_table" class="table table-bordered data-table">
					<thead>
					    <tr>
						    <th>{{ _lang('Name') }}</th>
							<th>{{ _lang('Account No') }}</th>
							<th>{{ _lang('Currency') }}</th>
							<th>{{ _lang('Openning Balance') }}</th>
							<th>{{ _lang('Created At') }}</th>
							<th class="text-center">{{ _lang('Action') }}</th>
					    </tr>
					</thead>
					<tbody>
					    @foreach($accounts as $account)
					    <tr data-id="row_{{ $account->id }}">
							<td class='name'>{{ $account->name }}</td>
							<td class='account_no'>{{ $account->account_no }}</td>
							<td class='currency_id'>{{ $account->currency->name }}</td>
							<td class='openning_balance'>{!! xss_clean(decimalPlace($account->openning_balance, $account->currency->name)) !!}</td>
							<td class='created_at'>{{ $account->created_at }}</td>
							<td class="text-center">
								<div class="dropdown">
								  <button class="btn btn-primary dropdown-toggle btn-xs" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
								  {{ _lang('Action') }}
								  <i class="fas fa-angle-down"></i>
								  </button>
								  <form action="{{ action('AccountController@destroy', $account['id']) }}" method="post">
									{{ csrf_field() }}
									<input name="_method" type="hidden" value="DELETE">
									
									<div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
										<button data-href="{{ action('AccountController@edit', $account['id']) }}" data-title="{{ _lang('Update Account') }}" class="dropdown-item dropdown-edit ajax-modal"><i class="mdi mdi-pencil"></i> {{ _lang('Edit') }}</button>
										<button data-href="{{ action('AccountController@show', $account['id']) }}" data-title="{{ _lang('View Account') }}" class="dropdown-item dropdown-view ajax-modal"><i class="mdi mdi-eye"></i> {{ _lang('View') }}</button>
										<button class="btn-remove dropdown-item" type="submit"><i class="mdi mdi-delete"></i> {{ _lang('Delete') }}</button>
									</div>
								  </form>
								</div>
							</td>
					    </tr>
					    @endforeach
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>

@endsection

resources/views/backend/account/view.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
	<div class="col-lg-12">
		<div class="card">
		    <div class="card-header">
				<span class="panel-title">{{ _lang('View Account') }}</span>
			</div>
			
			<div class="card-body">
			   <table class="table table-bordered">
					<tr><td>{{ _lang('Name') }}</td><td>{{ $account->name }}</td></tr>
					<tr><td>{{ _lang('Account No') }}</td><td>{{ $account->account_no }}</td></tr>
					<tr><td>{{ _lang('Account Currency') }}</td><td>{{ $account->currency->name }}</td></tr>
					<tr>
						<td>{{ _lang('Openning Balance') }}</td>
						<td>{!! xss_clean(decimalPlace($account->openning_balance,$account->currency->name)) !!}</td>
					</tr>
					<tr><td>{{ _lang('Contact Person') }}</td><td>{{ $account->contact_person }}</td></tr>
					<tr><td>{{ _lang('Contact Email') }}</td><td>{{ $account->contact_email }}</td></tr>
					<tr><td>{{ _lang('Note') }}</td><td>{{ $account->note }}</td></tr>
				</table>
			</div>
	    </div>
	</div>
</div>
@endsection